# bap
**B**ead-based sc**A**TAC-seq data **P**rocessing

## About
This is an integrated `python` (>= 3.6) and `R` package that
performs analysis and identification of barcode multiplets and processes
data files for downstream analyses for droplet-based single-cell ATAC-seq data. 

## Documentation

[See the bap wiki page](https://github.com/caleblareau/bap/wiki) for details and FAQs about bap.

options(warn=-1)

suppressMessages(suppressWarnings(library(Rsamtools)))
suppressMessages(suppressWarnings(library(GenomicAlignments)))
suppressMessages(suppressWarnings(library(GenomicRanges)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(tools)))

"%ni%" <- Negate("%in%")

# This function / script for a given .bam file saves a .rds file
# For each pair of barcodes given how many times they share an identical fragment in this 
# given chromosome

# TO DO:
# parameterize mapq and properpair

args <- commandArgs(trailingOnly = TRUE)

if(file_path_sans_ext(basename(args[1])) == "R"){
  i <- 2
} else { # Rscript
  i <- 0
}
bamfile <- args[i+1]
barcodeTag <- args[i+2]
barcodeQuantFile <- args[i+3]
blacklistRegionsFile <- args[i+4]

# Don't execute-- strictly for testing
if(FALSE){
  base <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests"
  bamfile <- paste0(base, "/", "bap_out/temp/filt_split/test.small.chr21.bam")
  barcodeTag <- "CB"
  barcodeQuantFile <- paste0(base, "/", "bap_out/final/test.small.barcodequants.csv")
  blacklistRegionsFile <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/bap/anno/blacklist/hg19.full.blacklist.bed"
}


# Import blacklist file
bldf <- data.frame(fread(blacklistRegionsFile))
blgr <- makeGRangesFromDataFrame(bldf, seqnames.field = "V1", start.field = "V2", end.field = "V3")

# Establish the barcode counts normally
bq <- data.frame(fread(barcodeQuantFile, header = TRUE, sep = ","))
keepBarcodesGlobal <- as.character(bq[,1])
rm(bq)

findDoubles_df <- function(bamfile, barcodeTag, mapqFilter = 0, properPair = TRUE){
  
  rdsOut <- gsub(".bam", "_overlapCount.rds", gsub("/filt_split/", "/frag_overlap/", bamfile))
  
  # Import Reads
  GA <- readGAlignments(bamfile, param = ScanBamParam(
    flag = scanBamFlag(isProperPair = properPair),
    tag = c(barcodeTag), mapqFilter = mapqFilter))
  
  # Filter 1 for eligible barcodes
  GAfilt1 <- GA[mcols(GA)[,barcodeTag] %in% keepBarcodesGlobal]
  rm(GA)
  
  # Filter 2 for blacklist
  ov_bl <- findOverlaps(GAfilt1, blgr)
  GAfilt <- GAfilt1[1:length(GAfilt1) %ni% queryHits(ov_bl)]
  rm(GAfilt1)
  
  # Pull out barcode for retained
  barcode <- mcols(GAfilt)[,barcodeTag]
  
  # Find exact fragments
  ov <- findOverlaps(GRanges(GAfilt), GRanges(GAfilt), type = "equal")
  
  # Determine baseline numbers
  XBtable <- table(mcols(GAfilt)[,barcodeTag])
  whichKeep <- names(XBtable)
  nKept <- as.numeric(XBtable); names(nKept) <- whichKeep
  rm(XBtable)
  
  # Make a dataframe of all combinations that have fragments overlapping
  hugeDF <-
    data.frame(
      bc1 = barcode[queryHits(ov)[ queryHits(ov) !=  subjectHits(ov)]],
      bc2 = barcode[subjectHits(ov)[ queryHits(ov) !=  subjectHits(ov)]],
      stringsAsFactors = FALSE
    )
  rm(ov)
  
  # One dplyr command to save the day -- determine occurences of overlapping reads
  hugeDF %>% filter(bc1 != bc2) %>%  # filter out reads that map to the same barcode
    mutate(barc1 = ifelse(bc1 > bc2, bc1, bc2),
           barc2 = ifelse(bc1 > bc2, bc2, bc1)) %>%  # switch to respect alphabetical order if necessary
    select(-one_of(c("bc1", "bc2"))) %>% # drop non-ordered barcode columns
    group_by(barc1, barc2) %>% summarise(n_both = n()) %>%  # group and count
    mutate(n_barc1 = nKept[barc1], n_barc2 = nKept[barc2]) %>% as.data.frame() -> implicatedPairs # keep baseline numbers
  rm(hugeDF)
  rm(barcode)
  saveRDS(implicatedPairs, file = rdsOut)
}

findDoubles_df(bamfile, barcodeTag)

options(warn=-1)
options(datatable.fread.input.cmd.message=FALSE)

suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(tools)))
suppressMessages(suppressWarnings(library(GenomicRanges)))

"%ni%" <- Negate("%in%")

options(scipen=999)

# This script processes fragments and annotates them with the bead barcode ID
# based on a separate dictionary file

substrRight <- function(x, n = 6){
  substr(x, nchar(x)-n+1, nchar(x))
}

# I/O
args <- commandArgs(trailingOnly = FALSE)
nn <- length(args)

# Import parameters using logic from the end
blacklist_file <- args[nn-4]
frag_bedpe_file <- args[nn-3]
read_bead_file <- args[nn-2] 
annotated_out_file <- args[nn-1] 
unique_count_out_file <- args[nn]

# For devel only
if(FALSE){
  blacklist_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/bap/anno/blacklist/hg19-mm10.full.blacklist.bed"
  frag_bedpe_file <-"~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/temp/filt_split/small_mix.hg19_chr1.frag.bedpe.gz"
  read_bead_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/temp/filt_split/small_mix.hg19_chr1.read_bead.tsv.gz"
  annotated_out_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/temp/filt_split/small_mix.hg19_chr1.frag.bedpe.annotated.tsv"
  unique_count_out_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/temp/filt_split/small_mix.hg19_chr1.bead_counts.tsv"
}

if(FALSE){
  
  base <- "/data/aryee/caleb/biorad/mouse_brain/N729_Exp110_sample8_combined_S1_2b2a2p/temp/filt_split/"
  blacklist_file <- "/data/aryee/caleb/pythondev/bap/bap/anno/blacklist/mm10.full.blacklist.bed"
  frag_bedpe_file <- paste0(base, "/", "N729_Exp110_sample8_combined_S1.chrX.frag.bedpe.gz")
  read_bead_file <-  paste0(base, "/", "N729_Exp110_sample8_combined_S1.chrX.read_bead.tsv.gz")
  annotated_out_file <- paste0(base, "/", "N729_Exp110_sample8_combined_S1.chrX.frag.bedpe.annotated.tsv.gz")
  unique_count_out_file <- paste0(base, "/", "N729_Exp110_sample8_combined_S1.chrX.bead_counts.tsv")
  
}

# Import frags and annotate with bead
frags <- fread(cmd = paste0("zcat < ", frag_bedpe_file), col.names = c("chr", "start", "end", "read_name")) 
bead_read <- fread(cmd = paste0("zcat < ", read_bead_file), col.names = c("read_name", "bead_id"))%>% na.omit() %>% unique()
mdf <- merge(frags, bead_read, by= "read_name") %>% na.omit()

# Filter for fragments overlapping the blacklist
bl <- fread(blacklist_file, col.names = c("chr", "start", "end")) %>% data.frame() %>% makeGRangesFromDataFrame()
ov_bl <- findOverlaps(bl, makeGRangesFromDataFrame(mdf))
blacklist_reads <- mdf$read_name[subjectHits(ov_bl)]
mdf <- mdf[read_name %ni% blacklist_reads]

# NOTE: the majority of the missing read names are instances where the MAPQ filter was not surpassed.

# Quantify the number of unique fragments per barcode
pcr_dup_df <- mdf[, .(count = .N), by = list(chr, start, end, bead_id)]
out_bead_quant <- pcr_dup_df[,.(nUnique = .N), by = bead_id]

# Export tables
write.table(mdf, file = annotated_out_file, row.names = FALSE, col.names = FALSE, quote = FALSE, sep = "\t")
write.table(out_bead_quant, file = unique_count_out_file, row.names = FALSE, col.names = FALSE, quote = FALSE, sep = "\t")

options(warn=-1)

suppressMessages(suppressWarnings(library(GenomicRanges)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(tools)))

"%ni%" <- Negate("%in%")

options(scipen=999)

#-----------------
# Parse arguments
#-----------------

args <- commandArgs(trailingOnly = TRUE)
if(file_path_sans_ext(basename(args[1])) == "R"){
  i <- 2
} else { # Rscript
  i <- 0
}

tempQcIn <- args[i+1]
mitoIn <- args[i+2]
firstQCout <- args[i+3]
species_mix <- args[i+4]

# For devel only
if(FALSE){
  tempQcIn <- "/Users/clareau/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/temp/jaccardPairsForIGV.basicQC-temp.tsv"
  mitoIn <- "/Users/clareau/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/temp/filt_split/jaccardPairsForIGV.chrM_frag.sumstats.tsv"
  firstQCout <- "/Users/clareau/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/final/jaccardPairsForIGV.basicQC.tsv"
  species_mix <- "none"
}

nuc_in <- fread(tempQcIn, col.names = c("cell_barcode", "n_total", "n_unique", "chromosome"))
mito_in <- fread(mitoIn, col.names = c("cell_barcode", "n_total", "n_unique", "chromosome"))

# Summarize counts
# No species mixing
nuc_sum <- nuc_in %>% group_by(cell_barcode) %>%
  summarize(totalNuclearFrags = sum(n_total), 
            uniqueNuclearFrags = sum(n_unique))

mito_sum <- mito_in %>% group_by(cell_barcode) %>%
  summarize(totalMitoFrags = sum(n_total), 
            uniqueMitoFrags = sum(n_unique))
basic_qc <- left_join(nuc_sum, mito_sum, by = "cell_barcode")

if(species_mix != "none"){
  
  nuc_in$mouse <- as.numeric(substr(nuc_in$chromosome,1,1) == "m")
  nuc_in$human <- as.numeric(substr(nuc_in$chromosome,1,1) == "h")
  
  human_df <- nuc_in %>% filter(human == 1) %>%
    group_by(cell_barcode) %>%
    summarize(totalHumanFrags = sum(n_total), 
              uniqueHumanFrags = sum(n_unique))
  
  mouse_df <- nuc_in %>% filter(mouse == 1) %>%
    group_by(cell_barcode) %>%
    summarize(totalMouseFrags = sum(n_total), 
              uniqueMouseFrags = sum(n_unique))
  QCstats <- left_join(basic_qc, human_df, by = "cell_barcode") %>%
    left_join(mouse_df, by = "cell_barcode")
  
} else {
  QCstats <- basic_qc
}

QCstats[is.na(QCstats)] <- 0
write.table(QCstats,
            file = firstQCout,
            quote = FALSE, row.names = FALSE, col.names = TRUE, sep = "\t")

options(warn=-1)

suppressMessages(suppressWarnings(library(tools)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))

# Simple function to determine the mode of a vector
# See here: https://stackoverflow.com/questions/2547402/is-there-a-built-in-function-for-finding-the-mode
get_mode <- function(x) {
  ux <- unique(x)
  ux[which.max(tabulate(match(x, ux)))]
}


get_local_minima_CL <- function(x) {
  
  # Find the indicies where we go from negative diff's to positive
  # if this returns less then 0 then we are descending
  y <- diff(c(Inf, x)) < 0L
  
  # rle to get the number of trues (downwards steps) and falses (upwards)
  # cumsum will then the index at which each of these inflections happens
  y <- cumsum(rle(y)$lengths)
  
  # If we only get three values, then this becomes a problem-- 
  # the every/other TRUE,FALSE,TRUE will only keep the extreme values
  # and then remove the only true minimum
  if(length(y) > 3){
    y <- y[seq.int(1L, length(y), 2L)]
  }
  
  # Seth's modification for removing duplicated elements at the beginning
  if (x[[1]] == x[[2]]) {
    y <- y[-1]
  }
  y
}

# Complicated function converted by CL
get_density_threshold_CL <- function(count_vector=NULL, type, logTransform = TRUE) {
  
  # Initialize using some reasonable value and filter anything below
  threshold <- min(get_mode(count_vector)) * 0.001
  filtered_tbl <- data.frame(count = count_vector[count_vector > threshold]) 
  
  # Parameterize the log transformation to work with non-count data
  # May get confusing evtually but for now, seemingly a decent hack
  if(logTransform){
    filtered_tbl$log_counts <- log10(filtered_tbl$count)
  } else{
    filtered_tbl$log_counts <- filtered_tbl$count
  }
  
  # Calculate the density using a gaussian kernel
  xx_values = 10000
  vector_density <- density(filtered_tbl$log_counts, bw=0.1, kernel="gaussian", n=xx_values,
                            from=min(filtered_tbl$log_counts),to=max(filtered_tbl$log_counts))
  
  local_mins <- get_local_minima_CL(vector_density$y)
  
  # If a minima was called at the very start or end of the distribution, remove it
  local_mins <- local_mins[!(local_mins == 1 | local_mins == length(vector_density$y))]
  
  # Find the first local min that meets the following criteria, starting right to left
  local_min <- Find(function(x) {
    
    # Make sure that the selected min includes at least 20% of barcodes
    # and that the difference between the min and the max differences by some appreciable amount
    # both in terms of absolute difference (Caleb changed 0.5 to 0.05) AND relative difference
    abs_difference <- ifelse(logTransform, 0.5, 0.05)
    
    return (x >= (0.2 * xx_values) & ((max(filtered_tbl$log_counts) - vector_density$x[x]) > abs_difference |
                                        (vector_density$x[x] < max(filtered_tbl$log_counts) / 2))) 
    
  }, rev(local_mins))
  
  if (!is.null(local_min)) {
    if(logTransform){
      threshold <- 10^vector_density$x[local_min]
    } else {
      threshold <- vector_density$x[local_min]
    }
    message("Setting knee threshold to: ", threshold)
    
  } else {
    
    # Null local min-- take a best guess
    if(logTransform){
      message("No reliable knee found-- setting threshold to 0")
      threshold <- 0
    } else {
      message("No reliable knee found-- setting threshold to 0")
      threshold <- 0
    }
    local_min <- 1
    local_mins <- 1
  }
  
  safety <- 0
  
  # Safe guard for Jaccard Index failure
  if(type == "jaccard" & (threshold > 0.5 | threshold < 0.000001)){
    message("No reliable knee found-- setting threshold to 0.005")
    safety <- 0.005
  } 
  
  # Safe guard for knee counts failure
    if(type == "bead" & (threshold > 100000 | threshold < 100)){
    message("No reliable knee found-- setting threshold to 500")
    safety <- 500
  } 
  
  # Safety is with the guard rails; threshold is what the knee calls
  safety <- ifelse(safety > 0, safety, threshold)
  
  return(c(safety, threshold))
}

options(warn=-1)
options(datatable.fread.input.cmd.message=FALSE)
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(tools)))
suppressMessages(suppressWarnings(library(GenomicRanges)))

"%ni%" <- Negate("%in%")

options(scipen=999)

# This script processes fragments and annotates them with the bead barcode ID
# based on a separate dictionary file

substrRight <- function(x, n = 6){
  substr(x, nchar(x)-n+1, nchar(x))
}

# I/O
args <- commandArgs(trailingOnly = FALSE)
nn <- length(args)

# Import parameters using logic from the end
frag_bedpe_file <- args[nn-3]
barcode_translate_file <- args[nn-2] 
frag_anno_file_out <- args[nn-1] 
sumstats_file_out <- args[nn]

# For devel only
if(FALSE){
  frag_bedpe_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/temp/filt_split/jaccardPairsForIGV.chr1.frag.bedpe.annotated.tsv.gz"
  barcode_translate_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/final/jaccardPairsForIGV.barcodeTranslate.tsv"
  frag_anno_file_out <-  "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/temp/filt_split/jaccardPairsForIGV.chr1.frag.bedpe.annotated.dedup.tsv.gz"
  sumstats_file_out <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/temp/filt_split/jaccardPairsForIGV.chr1_frag.sumstats.tsv"
}

# Import frags and annotate with cell barcode ID
frags <- fread(cmd = paste0("zcat < ", frag_bedpe_file), col.names = c("read_name","chr", "start", "end", "bead_barcode"), header = FALSE) 
barcode_translate <- fread(barcode_translate_file, col.names = c("bead_barcode", "cell_barcode"), header = FALSE)
mdf <- merge(frags, barcode_translate, by= "bead_barcode")

# Group by the cell barcode and 1) get representative read 2) get summary stats 

# Part 1 -- deduplicate reads over the cell barcode
pcr_dup_df <- mdf[, .I[1], by = list(chr, start, end, cell_barcode)]
pcr_dup_df2 <- data.table(
  pcr_dup_df[,c("chr", "start", "end", "cell_barcode")], 
  read_name = mdf$read_name[pcr_dup_df[["V1"]]]
)
rm(pcr_dup_df)

# Part 2 -- count fragments for summary statistics
dedup_count <- pcr_dup_df2[, .(n_unique = .N), by = cell_barcode]
raw_count <- mdf[, .(n_total = .N), by = cell_barcode]
merge_ss <- merge(raw_count, dedup_count, by = "cell_barcode")
merge_ss$chr <- as.character(mdf[1,"chr"])

# Export deduplicated fragments
frag_anno_file_out_nocompress <- frag_anno_file_out
pcr_dup_df2 <- pcr_dup_df2[order(start)]
write.table(pcr_dup_df2, file = frag_anno_file_out_nocompress,
            row.names = FALSE, col.names = FALSE, quote = FALSE, sep = "\t")

# Export summary statistics
write.table(merge_ss, file = sumstats_file_out,
            row.names = FALSE, col.names = FALSE, quote = FALSE, sep = "\t")

options(warn=-1)
options(datatable.fread.input.cmd.message=FALSE)

suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(tools)))
suppressMessages(suppressWarnings(library(GenomicRanges)))

"%ni%" <- Negate("%in%")

options(scipen=999)

# This script takes fragments and cleans them up (PCR deduplication; sort by coordinate)

substrRight <- function(x, n = 6){
  substr(x, nchar(x)-n+1, nchar(x))
}

# I/O
args <- commandArgs(trailingOnly = FALSE)
nn <- length(args)

# Import parameters using logic from the end
blacklist_file <- args[nn-2]
frag_bedpe_file <- args[nn-1]
out_file <- args[nn] 

# Import frags and annotate with bead
frags <- fread(cmd = paste0("cat < ", frag_bedpe_file), col.names = c("chr", "start", "end", "read_name")) 

# Filter for fragments overlapping the blacklist
bl <- fread(paste0("cat < ", blacklist_file), col.names = c("chr", "start", "end")) %>% data.frame() %>% makeGRangesFromDataFrame()
ov_bl <- findOverlaps(bl, makeGRangesFromDataFrame(frags))
blacklist_reads <- frags$read_name[subjectHits(ov_bl)]
frags <- frags[read_name %ni% blacklist_reads]

# NOTE: the majority of the missing read names are instances where the MAPQ filter was not surpassed.

# Perform PCR deduplication
pcr_dedup_df <- frags[, .(count = .N), by = list(chr, start, end)]
pcr_dedup_df <- pcr_dedup_df[order(start)]

# Export tables
write.table(pcr_dedup_df %>% dplyr::select(c("chr", "start", "end")),
            file = out_file, row.names = FALSE, col.names = FALSE, quote = FALSE, sep = "\t")

options(warn=-1)

suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(tools)))

"%ni%" <- Negate("%in%")

options(scipen=999)

args <- commandArgs(trailingOnly = TRUE)
if(file_path_sans_ext(basename(args[1])) == "R"){
  i <- 2
} else { # Rscript
  i <- 0
}

out_directory <- args[i+1] # directory of final output
keep_temp_files <- args[i+2] # whether or not to keep temporary files
barcodeQuantsFile <- args[i+3]

# For devel only
if(FALSE){
  out_directory <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out"
  keep_temp_files <= "True"
  barcodeQuantsFile <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/final/test.small.barcodequants.csv"
}

possible_ncRead <- list.files(paste0(out_directory, "/temp/", "filt_split"), full.names = TRUE, pattern = "*_ncRead.tsv$")
if(length(possible_ncRead) > 0){
  
  # Filter out files that have zero size
  possible_ncRead <- possible_ncRead[file.info(possible_ncRead)$size > 0]
  
  lapply(possible_ncRead, function(file){
    data.frame(table(fread(file)[[2]]))
  }) %>% rbindlist() %>% data.frame() -> count_ncDF
  
  # Aggregate the number of counts of NC reads across chromosomes
  count_ncDF$Var1 <- as.numeric(as.character(count_ncDF$Var1))
  count_ncDF %>% group_by(Var1) %>% summarise(Total = sum(Freq)) %>% arrange(Var1) %>% data.frame() -> out_count
  colnames(out_count) <- c("NC_value", "NumberOfReads")
  
  write.table(out_count,
              file = gsub(".barcodequants.csv$", ".NCsumstats.tsv", barcodeQuantsFile),
              quote = FALSE, row.names = FALSE, col.names = TRUE, sep = "\t")
  
  rm(count_ncDF)
  
  # Possibly remove files at this point
  if(keep_temp_files != "True"){
    toke <- lapply(possible_ncRead, file.remove)
  }
}

# Augment quants file
quants <- data.frame(fread(barcodeQuantsFile))
quants$TotalNC <- 0

possible_ncBarcode <- list.files(paste0(out_directory, "/temp/", "filt_split"), full.names = TRUE, pattern = "*_ncBarcode.tsv$")
if(length(possible_ncBarcode) > 0){
  
  # Filter out files that have zero size
  possible_ncBarcode <- possible_ncBarcode[file.info(possible_ncBarcode)$size > 0]
  
  # Import across all 
  lapply(possible_ncBarcode, function(file){
    data.frame(fread(file))
  }) %>% rbindlist() %>% data.frame()  %>% group_by(V1) %>% summarise(totalNC = sum(V2)) %>% data.frame() -> count_bcDF
  vec <- as.numeric(count_bcDF$totalNC); names(vec) <- as.character(count_bcDF$V1)
  
  # Update values in quants if present here
  quants$TotalNC <- sapply(1:dim(quants), function(j){
    bc <- as.character(quants[j,"Barcode"])
    ifelse(bc %in% names(vec), vec[bc], 0)
  })
  
  if(keep_temp_files != "True"){
    toke <- lapply(possible_ncBarcode, file.remove)
  }
}

# Write back out with new column
write.table(quants,
            file = barcodeQuantsFile,
            quote = FALSE, row.names = FALSE, col.names = TRUE, sep = ",")

options(warn=-1)

suppressMessages(suppressWarnings(library(Rsamtools)))
suppressMessages(suppressWarnings(library(GenomicAlignments)))
suppressMessages(suppressWarnings(library(GenomicRanges)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(tools)))

"%ni%" <- Negate("%in%")

options(scipen=999)

# Working with the raw .bam file to generate QC statistics 
# Per barcode 

#-----------------
# Helper Functions
#-----------------

# See https://github.com/broadinstitute/picard/blob/master/src/main/java/picard/sam/DuplicationMetrics.java#L115
estimateLibrarySize <- function(nTotal, nUnique){
  
  f <- function(x, c, n) {
    return(c / x - 1 + exp(-n / x))
  }
  
  m = 1
  M = 100
  
  nDuplicates <- (nTotal - nUnique) + 1 # charity to handle only unique reads observed
  
  if (nUnique > nTotal | (f(m * nUnique, nUnique, nTotal) < 0) | nUnique < 0 | nTotal < 0 | nDuplicates < 0) {
    message("Library size returns 0 -- invalid inputs; check this cell more closely")
    return(0)
  }
  
  while (f(M * nUnique, nUnique, nTotal) > 0) {
    M <- M*10.0
  }
  
  for(i in seq(0, 40)) {
    r <-  (m + M) / 2.0
    u <- f(r * nUnique, nUnique, nTotal);
    if (u == 0) {
      break
    } else if (u > 0) {
      m = r
    } else if (u < 0) {
      M = r
    }
  }
  
  return(round(nUnique * (m + M) / 2.0))
}

estimateDuplicateRate <- function(nTotal, nUnique){
  round((nTotal-nUnique)/nTotal, 3)
}

#-----------------
# Parse arguments
#-----------------

args <- commandArgs(trailingOnly = TRUE)
if(file_path_sans_ext(basename(args[1])) == "R"){
  i <- 2
} else { # Rscript
  i <- 0
}


bamFile <- args[i+1] # directory of .rds files
barcodeTranslateFile <- args[i+2] # file path to the number of barcodes for each observed barcode
barcodeQuantsFile <- args[i+3] # filepath to write the implicated barcode pairs
tssFile <- args[i+4]
dropbarcodeTag <- args[i+5]
blacklistFile <- args[i+6]
peakFile <- args[i+7]
speciesMix <- args[i+8]
oneone <- args[i+9]

# For devel only
if(FALSE){
  bamFile <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/final/test.small.bap.bam"
  barcodeTranslateFile <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/final/test.small.barcodeTranslate.tsv"
  barcodeQuantsFile <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/final/test.small.barcodequants.csv"
  tssFile <-  "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/bap/anno/TSS/hg19.refGene.TSS.bed"
  dropbarcodeTag <- "DB"
  blacklistFile <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/bap/anno/blacklist/hg19.full.blacklist.bed"
  peakFile <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/data/test.small.peaks.bed"
  speciesMix <- "no"
  oneone <- "yes"
}

# We only need the read names if we have a valid peak file
import.names <- peakFile != "none"

# Parse .bam file
GA <- readGAlignments(bamFile, use.names = import.names, param = ScanBamParam(
  flag = scanBamFlag(isProperPair = TRUE),
  tag = c(dropbarcodeTag), mapqFilter = 0, what="isize"))

# Set up TSS file for scoring
tssdf <- data.frame(fread(tssFile))
tssdf$V2 <- tssdf$V2 - 2000
tssdf$V3 <- tssdf$V3 + 2000

# Deal with TSS enrichment %
promoter <- makeGRangesFromDataFrame(tssdf, seqnames.field = "V1", start.field = "V2", end.field = "V3")
ovTSS <- findOverlaps(promoter, GA)
df <- data.frame(mcols(GA))

df$TSS <- as.numeric(1:dim(df)[1] %in% subjectHits(ovTSS))
rm(ovTSS); rm(promoter)

# Deal with FRIP if we have a peak file
if(peakFile != "none"){
  peakdf <- data.frame(fread(peakFile))[,c(1,2,3)]
  colnames(peakdf) <- c("V1", "V2", "V3")
  peaks <- makeGRangesFromDataFrame(peakdf, seqnames.field = "V1", start.field = "V2", end.field = "V3")
  ovPEAK <- findOverlaps(peaks, GA)
  df$Peak <- as.numeric(1:dim(df)[1] %in% subjectHits(ovPEAK))
  rm(peakdf)
} else{
  df$Peak <- 0
}


if(speciesMix == "no"){
  colnames(df) <- c("isize", "DropBarcode", "TSS", "Peak")
  sbdf <- df %>% group_by(DropBarcode) %>% summarise(FRIP = round(mean(Peak), 3),
                                                     tssProportion = round(mean(TSS), 3),
                                                     meanInsertSize = round(mean(abs(isize))),
                                                     medianInsertSize = round(median(abs(isize)))) %>% data.frame()
} else {
  df$mouse <- as.numeric(substr(as.character(seqnames(GA)),1,1) == "m")
  df$human <- as.numeric(substr(as.character(seqnames(GA)),1,1) == "h")
  colnames(df) <- c("isize", "DropBarcode", "TSS", "Peak", "mouse", "human")
  sbdf <- df %>% group_by(DropBarcode) %>% summarise(FRIP = round(mean(Peak), 3),
                                                     tssProportion = round(mean(TSS), 3),
                                                     meanInsertSize = round(mean(abs(isize))),
                                                     medianInsertSize = round(median(abs(isize))),
                                                     nHumanReads = sum(human),
                                                     nMouseReads = sum(mouse)) %>% data.frame()
}
rm(df)

# Import old barcode stats and merge with what has been computed
mss <- data.frame(merge(fread(barcodeTranslateFile), fread(barcodeQuantsFile), by.x = "BeadBarcode", by.y = "Barcode"))

# Also subtract out the total number of overlap reads (divided by 2 sincel double counting) to get proper estimate of # 
# of unique nuclear reads. This technically will be a slight UNDERestimate in cases of 3 or more drops merging where
# all 3 share the same read, but we assume that this is a weird edge case that infrequently happens and thus is not
# of the utmost importance in handling here. 
msss <- mss %>% group_by(DropBarcode) %>% summarise(uniqueNuclearFrags = round(sum(UniqueNuclear) - (sum(OverlapReads)/2)), 
                                                    totalNuclearFrags = sum(TotalNuclear),
                                                    totalMitoFrags = sum(TotalMito),
                                                    totalNCfilteredFrags = sum(TotalNC)) %>% data.frame()

msss$duplicateProportion <- estimateDuplicateRate(msss$totalNuclearFrags, msss$uniqueNuclearFrags)
msss$librarySize <- sapply(1:dim(msss)[1], function(i){
  estimateLibrarySize(msss[i,"totalNuclearFrags"],msss[i,"uniqueNuclearFrags"])})
qcStats <- merge(sbdf, msss)

# add barcodes back if we need to (specified with the one to one option)
if(oneone == "yes"){
  translateDF <- read.table(barcodeTranslateFile, header = TRUE, stringsAsFactors = FALSE)
  qcStatsDF <- qcStats
  tvec <- translateDF[,1]; names(tvec) <- translateDF[,2]
  qcStats <- qcStatsDF
  qcStats$OriginalBarcode <- tvec[as.character(qcStats$DropBarcode)] 
}

if(peakFile != "none"){
  # recall ovPEAK from above 

  id <- factor(mcols(GA)[,dropbarcodeTag], levels = as.character(qcStats$DropBarcode))
  countdf <- data.frame(peak = queryHits(ovPEAK), sample = as.numeric(id)[subjectHits(ovPEAK)], read = names(GA)[subjectHits(ovPEAK)]) %>%
    distinct() %>%  # by filtering on distinct read / peak / sample trios, ensure that PE reads that overlap peak aren't double counted
    select(-one_of("read")) %>% 
    group_by(peak,sample) %>% summarise(count = n()) %>% data.matrix()
  #rm(ovPEAK)
  
  m <- Matrix::sparseMatrix(i = c(countdf[,1], length(peaks)), j =c(countdf[,2], 1), x = c(countdf[,3],0))
  colnames(m) <- levels(id)
  SE <- SummarizedExperiment(
    rowRanges = peaks, 
    assays = list(counts = m),
    colData = qcStats
  )
  saveRDS(SE, gsub(".barcodequants.csv$", ".SE.rds", barcodeQuantsFile))
}

rm(GA)

write.table(qcStats,
            file = gsub(".barcodequants.csv$", ".QCstats.csv", barcodeQuantsFile),
            quote = FALSE, row.names = FALSE, col.names = TRUE, sep = ",")

# Reformat the Barcode Translate file to remove the spurious additional column that was needed
write.table(data.frame(fread(barcodeTranslateFile))[,c(1,2)],
            file = barcodeTranslateFile, quote = FALSE, row.names = FALSE, col.names = FALSE, sep = "\t")

options(warn=-1)

suppressMessages(suppressWarnings(library(tools)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))

# I/O
args <- commandArgs(trailingOnly = FALSE)

# Parse parameters working backwards since I am keeping all of them
# to be able to source the knee call Rscript
nn <- length(args)
vals_file <- args[nn-2]
logTransform <- args[nn-1]
column_name <- args[nn]

# Grab knee call functions from figuring out where this script lives and then changing the file name
needle <- "--file="
match <- grep(needle, args)
source(normalizePath(gsub("10b_knee_execute.R", "00_knee_CL.R", gsub(needle, "", args[match]))))

# Import data supplied by the user
vec_values <- as.numeric(fread(vals_file)[[as.character(column_name)]])

# Call knee
estimated_knee_threshold <- get_density_threshold_CL(vec_values, "bead", as.logical(as.numeric(as.character(logTransform))))

# Write value to table
write.table(data.frame(estimated_knee_threshold), row.names = FALSE, col.names = FALSE, 
            quote = FALSE, sep = "", file = paste0(vals_file, "_kneeValue.txt"))

options(warn=-1)

suppressMessages(suppressWarnings(library(ggplot2)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(tools)))

"%ni%" <- Negate("%in%")

# Helper functions
get_ticks <- function(data, col_name) {
  n1 <- floor(log10(range(data[col_name])))
  if (n1[1] == -Inf) n1[1] = 0
  pow <- seq(n1[1], n1[2]+1)
  ticks <- as.vector(sapply(pow, function(p) (c(1,5)*10^p)))
  return(ticks)
}

args <- commandArgs(trailingOnly = TRUE)

if(file_path_sans_ext(basename(args[1])) == "R"){
  i <- 2
} else { # Rscript
  i <- 0
}
bapParamsFile <- args[i+1]
beadBarcodesFile <- args[i+2]
jaccardFragsFile <- args[i+3]

# Don't execute-- strictly for testing
if(FALSE){
  bapParamsFile <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/knee/test.small.bapParams.csv"
  beadBarcodesFile <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/knee/test.small.barcodeQuantSimple.csv"
  jaccardFragsFile <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/final/test.small.implicatedBarcodes.csv.gz"
  
}

# Make output files
beadBarcodesKneePlot <- gsub(".barcodeQuantSimple.csv", ".beadBarcodeKnee.pdf", beadBarcodesFile)
jaccardKneePlot <- gsub(".barcodeQuantSimple.csv", ".jaccardOverlapKnee.pdf", beadBarcodesFile)

stopifnot(file.exists(bapParamsFile))

# Parse knee-called values
bapParams <- read.table(bapParamsFile, sep = ",")
bead_threshold <- bapParams %>% filter(V1 == "bead_threshold") %>% pull(V2) %>% as.character() %>% as.numeric()
jaccard_threshold <- bapParams %>% filter(V1 == "jaccard_threshold") %>% pull(V2)%>% as.character() %>% as.numeric()
bead_threshold <- ifelse(is.na(bead_threshold), 0, bead_threshold)

# Make bead barcodes knee plot
if(file.exists(beadBarcodesFile)){
  
  # Import bead counts
  bead_vec <- fread(beadBarcodesFile)[["V2"]]
  
  # Make a data frame for plotting with ticks
  barcode_counts_mut <- data.frame(count = bead_vec) %>%
    arrange(desc(count)) %>%
    mutate(rank = 1:n(), passKnee = count > bead_threshold)
  ticks_at_y <- get_ticks(barcode_counts_mut, 'count')
  ticks_at_x <- get_ticks(barcode_counts_mut, 'rank')
  x_intercept_bead <- sum(barcode_counts_mut$passKnee)
  
  barcode_counts_plot <- barcode_counts_mut %>%
    ggplot(aes(x=rank, y=count)) +
    scale_y_log10(breaks = ticks_at_y, labels = as.integer(ticks_at_y)) +
    scale_x_log10(breaks = ticks_at_x, labels = as.integer(ticks_at_x)) +
    xlab("Barcode in rank-descending order") +
    ylab("Reads per barcode") +
    theme(axis.text.x = element_text(angle=90)) +
    geom_point(aes(color = passKnee)) +
    scale_color_manual(values = c("black", "dodgerblue3")) +
    theme(legend.position = c(0.02, 0.1)) +
    labs(color = "Pass Knee") +
    geom_vline(xintercept = x_intercept_bead, color = "dodgerblue4") +
    geom_hline(yintercept = bead_threshold, color = "dodgerblue4")
  
  # Export to PDF for vectorized stuff
  ggsave(barcode_counts_plot, file = beadBarcodesKneePlot,
         width = 6, height = 6, useDingbats=FALSE)
  
  # Also save as a png for good measure
  ggsave(barcode_counts_plot, file = gsub(".pdf$", ".png", beadBarcodesKneePlot),
         width = 6, height = 6)
  
  #--------------------------
  # Additional QC plots
  #--------------------------
  
  big_c <- ceiling(max(log10(barcode_counts_mut$count)))
  
  # Density Plot
  barcode_counts_mut %>%
    filter(count > 50) %>% 
    ggplot() +
    geom_density(aes(x = log10(count+1))) +
    ylab("Density") +
    scale_x_continuous(limits = c(0,big_c)) +
    xlab("Count per barcode log10") +
    geom_vline(xintercept = log10(x_intercept_bead), colour= "dodgerblue4") ->
    density_plot
  
  beadBarcodesKneeDensityPlot <- gsub(".barcodeQuantSimple.csv", ".beadBarcodeKneeDensity.pdf", beadBarcodesFile)
  ggsave(density_plot, file = beadBarcodesKneeDensityPlot, useDingbats=FALSE, 
         width = 6, height = 6)
  
  # Knee Plot
  barcode_counts_mut %>%
    mutate(cum_sum = cumsum(count)) %>%
    ggplot() +
    geom_line(aes(x=rank, y=cum_sum)) +
    ylab("Cumulative read count") +
    xlab("Barcode rank") +
    geom_vline(xintercept = x_intercept_bead, colour= "dodgerblue4") ->
    knee_plot
  
  beadBarcodesKneeCurvePlot <- gsub(".barcodeQuantSimple.csv", ".beadBarcodeKneeCurve.pdf", beadBarcodesFile)
  ggsave(knee_plot, file = beadBarcodesKneeCurvePlot,
         width = 6, height = 6,  useDingbats=FALSE)
  
}

# Make jaccard overlaps knee plot
if(file.exists(jaccardFragsFile)){
  
  # Import jaccard overlap measures
  jaccard_frag_vec <- fread(cmd = paste0("zcat < ", jaccardFragsFile, " | head -1000000"))[["jaccard_frag"]]
  
  # Make a data frame for plotting with ticks
  jaccard_mut <- data.frame(jaccard_frag = jaccard_frag_vec) %>%
    arrange(desc(jaccard_frag)) %>%
    mutate(rank = 1:n(), passKnee = jaccard_frag > jaccard_threshold)
  ticks_at_y <- get_ticks(jaccard_mut, 'jaccard_frag')
  ticks_at_x <- get_ticks(jaccard_mut, 'rank')
  x_intercept_frag <- sum(jaccard_mut$passKnee)
  
  jaccard_plot <- jaccard_mut %>%
    ggplot(aes(x=rank, y=jaccard_frag)) +
    scale_y_log10(breaks = ticks_at_y, labels = as.numeric(ticks_at_y)) +
    scale_x_log10(breaks = ticks_at_x, labels = as.integer(ticks_at_x)) +
    xlab("bap overlap score in rank-descending order") +
    ylab("bap overlap score per barcode pair") +
    theme(axis.text.x = element_text(angle=90)) +
    geom_point(aes(color = passKnee)) +
    scale_color_manual(values = c("black", "dodgerblue3")) +
    theme(legend.position = c(0.02, 0.1)) +
    labs(color = "Pass Knee") +
    geom_vline(xintercept = x_intercept_frag, color = "dodgerblue4") +
    geom_hline(yintercept = jaccard_threshold, color = "dodgerblue4")
  
  # Export to PDF for vectorized stuff
  ggsave(jaccard_plot, file = jaccardKneePlot,
         width = 6, height = 6, useDingbats=FALSE)
  
  # Also save as a png for good measure
  ggsave(jaccard_plot, file = gsub(".pdf$", ".png", jaccardKneePlot),
         width = 6, height = 6)
  
}
statusUpdateTxt <- gsub(".barcodeQuantSimple.csv", ".kneesPlotted.txt", beadBarcodesFile)
write.table(data.frame("yes"), 
            file = statusUpdateTxt, row.names = FALSE, col.names = FALSE, sep = "\t", quote = FALSE)

options(warn=-1)

suppressMessages(suppressWarnings(library(Rsamtools)))
suppressMessages(suppressWarnings(library(GenomicAlignments)))
suppressMessages(suppressWarnings(library(GenomicRanges)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(tools)))

"%ni%" <- Negate("%in%")

# This script takes a given bam file

args <- commandArgs(trailingOnly = TRUE)

if(file_path_sans_ext(basename(args[1])) == "R"){
  i <- 2
} else { # Rscript
  i <- 0
}
bamfile <- args[i+1]
barcodeTag <- args[i+2]

if(FALSE){
  base <- "/Volumes/dat/Research/BuenrostroResearch/lareau_dev/bap/tests"
  bamfile <- paste0(base, "/", "bap_out/temp/filt_split/test.small.chr21.bam")
  barcodeTag <- "CB"
}

tsvOut <- gsub(".bam", "_ncRead.tsv", bamfile)

# Import Reads and make a data.frame
GA <- readGAlignments(bamfile, param = ScanBamParam(tag = c(barcodeTag, "NS")), use.names = TRUE)
df <- data.frame(read = names(GA), barcode = mcols(GA)[,barcodeTag],
                 NS = mcols(GA)[,"NS"],
                 chr = as.character(seqnames(GA)), bp = start(GA), stringsAsFactors = FALSE) 
rm(GA)

# Do read pairing
df %>% filter(NS > 1) %>% group_by(read) %>% summarize(barcode = min(barcode), chr = min(chr), bp1 = min(bp), bp2 = max(bp)) %>%
  group_by(chr, bp1, bp2) %>% mutate(count = n()) -> odf

# Append back the ones
ones_df <- data.frame(read = unique(df$read[df$read %ni% odf$read]),
                      count = 1)

write.table(rbind(ones_df,  odf[,c("read", "count")]), file = tsvOut,
            sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)

                                    

options(warn=-1)

suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(tools)))

"%ni%" <- Negate("%in%")

options(scipen=999)

# This function / script for processed chromosome files to produce consensus barcode doublets
# as well as summary and QC metrics and visuals

substrRight <- function(x, n = 6){
  substr(x, nchar(x)-n+1, nchar(x))
}

# I/O
args <- commandArgs(trailingOnly = FALSE)

# Grab knee call functions from figuring out where this script lives and then changing the file name
needle <- "--file="
match <- grep(needle, args)
source(normalizePath(gsub("13_callDoublets.R", "00_knee_CL.R", gsub(needle, "", args[match]))))

# Import parameters using logic from the end3
nn <- length(args)
rdsDir <- args[nn-6] # directory of .rds files
nbcin <- args[nn-5] # file path to the number of barcodes for each observed barcode
tblOut <- args[nn-4] # filepath to write the implicated barcode pairs
min_jaccard_frag <- as.numeric(args[nn-3])
name <- args[nn-2] #name prefix for file naming convention
one_to_one <- args[nn-1] #arguement for keeping bead : drop conversion 1 to 1
barcoded_tn5 <- args[nn]

# Fix to R boolean
one_to_one <- one_to_one == "True" 
barcoded_tn5 <- barcoded_tn5 == "True" 

# Replace the .gz convention
tblOut <- gsub(".gz$", "", tblOut)

# For devel only
if(FALSE){
  rdsDir <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/temp/frag_overlap"
  nbcin <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/final/test.small.barcodequants.csv"
  tblOut <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap_out/final/test.small.implicatedBarcodes.csv"
  name <- "test.small"
  min_jaccard_frag <- 0.005
  one_to_one <- FALSE
  barcoded_tn5 <- TRUE
}
rdsFiles <- list.files(rdsDir, full.names = TRUE)
rdsFiles <- rdsFiles[sapply(lapply(rdsFiles,file.info), function(x) x$size) > 0]

# Import the number of barcodes per bead
nBC <- data.frame(fread(nbcin, header = TRUE)) %>% arrange(desc(UniqueNuclear));
if(ncol(nBC) == 4){
  colnames(nBC) <- c("BeadBarcode", "UniqueFragCount", "TotalFragCount", "TotalMitoCount")
} else {
  colnames(nBC) <- c("BeadBarcode", "UniqueFragCount", "TotalFragCount", "TotalMitoCount", "TotalNC")
}

# Set up vector of unique fragment counts to annotate in the overlap df
nBCv <- nBC$UniqueFragCount; names(nBCv) <- nBC$BeadBarcode

# Implicate overlapping fragments
if(!barcoded_tn5){
  lapply(rdsFiles, readRDS) %>%
    rbindlist(fill = TRUE) %>% as.data.frame() %>%
    group_by(barc1, barc2) %>%
    summarise(N_both = sum(n_both)/2) %>% # overlaps called twice
    filter(N_both > 1) %>% mutate(N_barc1 = nBCv[barc1], N_barc2 = nBCv[barc2]) %>% 
    mutate(jaccard_frag = round((N_both)/(N_barc1 + N_barc2 - N_both + 1),4)) %>% 
    filter(jaccard_frag > 0) %>% 
    arrange(desc(jaccard_frag)) %>% data.frame() -> ovdf

# Only consider merging when the Tn5 is the same
} else {
  lapply(rdsFiles, readRDS) %>%
    rbindlist(fill = TRUE) %>% as.data.frame() %>%
    mutate(tn5_1 = substrRight(barc1),
           tn5_2 = substrRight(barc2)) %>%
    filter(tn5_1 == tn5_2) %>% 
    group_by(barc1, barc2) %>%
    summarise(N_both = sum(n_both)/2) %>% # overlaps called twice
    filter(N_both > 1) %>% mutate(N_barc1 = nBCv[barc1], N_barc2 = nBCv[barc2]) %>% 
    mutate(jaccard_frag = round((N_both)/(N_barc1 + N_barc2 - N_both + 1),4)) %>% 
    filter(jaccard_frag > 0) %>% 
    arrange(desc(jaccard_frag)) %>% data.frame() -> ovdf
}

# Call knee if we need to
if(min_jaccard_frag == 0){
  message("Computing jaccard index for bead merging via a knee call--")
  two <- get_density_threshold_CL(head(ovdf$jaccard_frag, 1000000), "jaccard", logTransform = TRUE)
  min_jaccard_frag <- two[1]
  called_jaccard_frag <- two[2]
  
  # Write out what gets called
  write(paste0("jaccard_threshold_nosafety,", as.character(called_jaccard_frag)),
        gsub("/final/", "/knee/", gsub(".implicatedBarcodes.csv$", ".bapParams.csv", tblOut)), append = TRUE)
  
  # Make a plot
  
  
}

# Append to bap parameters
write(paste0("jaccard_threshold,", as.character(min_jaccard_frag)),
      gsub("/final/", "/knee/", gsub(".implicatedBarcodes.csv$", ".bapParams.csv", tblOut)), append = TRUE)

# Export the implicated barcodes
ovdf$merged <- ovdf$jaccard_frag > min_jaccard_frag
write.table(ovdf, file = tblOut,
            quote = FALSE, row.names = FALSE, col.names = TRUE, sep = ",")
system(paste0("gzip ", tblOut))

# Now filter based on the min_jaccard_frag
ovdf %>% filter(jaccard_frag > min_jaccard_frag) %>% data.frame() -> ovdf

# Guess at how wide we need to make the barcodes to handle leading zeros
guess <- ceiling(log10(dim(nBC)[1]))

nBC_keep <- nBC; nBC_keep$DropBarcode <- ""; nBC_keep$OverlapReads <- ""

# Loop through and eat up barcodes
idx <- 1
while(dim(nBC)[1] > 0){
  barcode <- as.character(nBC[1,1])
  barcode_combine <- barcode
  OverlapReads = 0
  
  # Find friends that are similarly implicated and append from Barcode 1
  friendsRow1 <- which(barcode ==  ovdf[,"barc1", drop = TRUE])
  if(length(friendsRow1) > 0){
    friends1 <- as.character(ovdf[friendsRow1,"barc2"])
    OverlapReads = OverlapReads + sum(ovdf[1:dim(ovdf)[1] %in% friendsRow1, "N_both"])
    ovdf <- ovdf[1:dim(ovdf)[1] %ni% friendsRow1,]
    barcode_combine <- c(barcode_combine, friends1)
  }
  
  # Find friends that are similarly implicated and append from Barcode 2
  friendsRow2 <- which(barcode ==  ovdf[,"barc2", drop = TRUE])
  if(length(friendsRow2) > 0){
    friends2 <- as.character(ovdf[friendsRow2,"barc1"])
    OverlapReads = OverlapReads + sum(ovdf[1:dim(ovdf)[1] %in% friendsRow2, "N_both"])
    ovdf <- ovdf[1:dim(ovdf)[1] %ni% friendsRow2,]
    barcode_combine <- c(barcode_combine, friends2)
  }
  
  # If user species one to one, then only remove that one barcode
  if(one_to_one){
    barcode_combine <- barcode
  }
  
  # Make a drop barcode and save our progress
  if(!barcoded_tn5){
    dropBarcode <- paste0(name, "_BC", formatC(idx, width=guess, flag="0", digits = 20), "_N", sprintf("%02d", length(barcode_combine)))
  } else {
    dropBarcode <- paste0(name, "_Tn5-", substrRight(barcode_combine), 
                          "_BC", formatC(idx, width=guess, flag="0", digits = 20),
                          "_N", sprintf("%02d", length(barcode_combine)))
  }
    
  # Annotate with new values
  nBC_keep[nBC_keep$BeadBarcode %in% barcode_combine, "DropBarcode"] <- dropBarcode
  nBC_keep[nBC_keep$BeadBarcode %in% barcode_combine, "OverlapReads"] <- OverlapReads
  
  idx <- idx + 1
  
  # Remove barcodes that we've dealt with
  nBC <- nBC[nBC$BeadBarcode %ni% barcode_combine,]
}

write.table(nBC_keep[,c("BeadBarcode", "DropBarcode", "OverlapReads")],
            file = gsub(".implicatedBarcodes.csv$", ".barcodeTranslate.tsv", tblOut),
            quote = FALSE, row.names = FALSE, col.names = TRUE, sep = "\t")

options(warn=-1)

suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(tools)))

"%ni%" <- Negate("%in%")

options(scipen=999)

# This function / script for processed chromosome files to produce consensus barcode doublets
# as well as summary and QC metrics and visuals

substrRight <- function(x, n = 6){
  substr(x, nchar(x)-n+1, nchar(x))
}

# I/O
args <- commandArgs(trailingOnly = FALSE)

# Grab knee call functions from figuring out where this script lives and then changing the file name
needle <- "--file="
match <- grep(needle, args)
source(normalizePath(gsub("23_callDoublets_bap2.R", "00_knee_CL.R", gsub(needle, "", args[match]))))

# Import parameters using logic from the end3
nn <- length(args)
rdsDir <- args[nn-8] # directory of .rds files
n_bc_file <- args[nn-7] # file for the number of reads supporting each barcode
hq_bc_file <- args[nn-6] # file for the HQ barcodes that were nominated
tblOut <- args[nn-5] # filepath to write the implicated barcode pairs
min_jaccard_frag <- as.numeric(args[nn-4])
name <- args[nn-3] #name prefix for file naming convention
one_to_one <- args[nn-2] #arguement for keeping bead : drop conversion 1 to 1
barcoded_tn5 <- args[nn-1]
barcode_prior_file <- args[nn]

# Fix to R boolean
one_to_one <- one_to_one == "True" 
barcoded_tn5 <- barcoded_tn5 == "True" 

# Replace the .gz convention
tblOut <- gsub(".gz$", "", tblOut)

# For devel only
if(FALSE){
  rdsDir <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/temp/frag_overlap"
  n_bc_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/knee/jaccardPairsForIGV.barcodeQuantSimple.csv"
  hq_bc_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/final/jaccardPairsForIGV.HQbeads.tsv"
  tblOut <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/final/o.tsv"
  min_jaccard_frag <- 0.005
  name <- "x"
  one_to_one <- FALSE
  barcoded_tn5 <- FALSE
  barcode_prior_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/data/jaccardPairsTest_sep.tsv"
  
}

rdsFiles <- list.files(rdsDir, full.names = TRUE, pattern = "_overlapCount.rds$")
rdsFiles <- rdsFiles[sapply(lapply(rdsFiles,file.info), function(x) x$size) > 0]


lapply(rdsFiles, readRDS) %>%
  rbindlist(fill = TRUE) -> inputDF

# Only consider merging when Tn5 is the same
if(barcoded_tn5){
  tn5_1 = substrRight(inputDF[["barc1"]])
  tn5_2 = substrRight(inputDF[["barc2"]])
  inputDF <- inputDF[tn5_1 == tn5_2]
}


# Import number of barcodes
valid_barcodes <- fread(hq_bc_file, col.names = c("bc"), header = FALSE)[["bc"]]
nBC <- fread(n_bc_file, col.names = c("BeadBarcode", "count"), sep = ",") %>%
  data.frame() %>% filter(BeadBarcode %in% valid_barcodes) %>% arrange(desc(count))
count_vec <- nBC$count*2; names(count_vec) <- as.character(nBC$BeadBarcode)

sum_dt <- inputDF[, .(N_both = sum(n_both)), by = list(barc1, barc2)] 
sum_dt$N_barc1 <- count_vec[sum_dt$barc1]
sum_dt$N_barc2 <- count_vec[sum_dt$barc2]

data.frame(sum_dt) %>% # fixed the previous divided by two in the upstream script (22) for overall accuracy
  mutate(jaccard_frag = round((N_both)/(N_barc1 + N_barc2 - N_both + 0.05), 5)) %>% 
  filter(jaccard_frag > 0) %>% 
  arrange(desc(jaccard_frag)) %>% data.frame() -> ovdf


# Call knee if we need to
if(min_jaccard_frag == 0){
  message("Computing jaccard index for bead merging via a knee call--")
  two <- get_density_threshold_CL(head(ovdf$jaccard_frag, 1000000), "jaccard", logTransform = TRUE)
  min_jaccard_frag <- two[1]
  called_jaccard_frag <- two[2]
  
  # Write out what gets called
  write(paste0("jaccard_threshold_nosafety,", as.character(called_jaccard_frag)),
        gsub("/final/", "/knee/", gsub(".implicatedBarcodes.csv$", ".bapParams.csv", tblOut)), append = TRUE)
  
}

# Append to bap parameters
write(paste0("jaccard_threshold,", as.character(min_jaccard_frag)),
      gsub("/final/", "/knee/", gsub(".implicatedBarcodes.csv$", ".bapParams.csv", tblOut)), append = TRUE)

ovdf$merged <- ovdf$jaccard_frag > min_jaccard_frag

# Merge barcodes above the knee unless there's a prior reason why we shouldn't
if(barcode_prior_file != "none"){
  
  # Import and assign each 
  bp_df <- fread(barcode_prior_file, header = FALSE) 
  feature_vec <- as.character(bp_df[["V2"]]); names(feature_vec) <- as.character(bp_df[["V1"]])
  merged_df <- ovdf %>% filter(merged)
  priorf1 <- feature_vec[as.character(merged_df[["barc1"]])] %>% unname()
  priorf2 <- feature_vec[as.character(merged_df[["barc2"]])] %>% unname()
  
  # Find conflicts,  missing values, and 
  conflicts <- priorf1 != priorf2
  sum_is_na <- sum(is.na(conflicts))
  sum_conflicts = sum(conflicts, na.rm = TRUE)
  sum_valid = sum(!conflicts, na.rm = TRUE)
  
  # Write out conflicts and filter if we observe them
  if(sum_conflicts > 0){
    conflictFile = gsub("/final/", "/knee/", gsub(".implicatedBarcodes.csv$", ".barcode_prior_conflicts.csv", tblOut))
    write.table(merged_df[which(conflicts),], file = conflictFile, row.names = FALSE, col.names = TRUE, sep = ",", quote = FALSE)
    ovdf <- ovdf[1:dim(ovdf)[1] %ni% which(conflicts),]
  }
  
  # Either way, write out statistics
  out_stat_prior_df <- data.frame(
    what = c("Valid merges (stil merged)", "Merges with 1 or more NA (still merged)", "Conflicted merges (not merged)"),
    count = c(sum_valid, sum_is_na, sum_conflicts)
  )
  statFile = gsub("/final/", "/knee/", gsub(".implicatedBarcodes.csv$", ".barcode_prior_stats.csv", tblOut))
  write.table(out_stat_prior_df, file = statFile, row.names = FALSE, col.names = FALSE, sep = ",", quote = FALSE)
  
} 


# Export the implicated barcodes
write.table(ovdf, file = tblOut,
            quote = FALSE, row.names = FALSE, col.names = TRUE, sep = ",")
system(paste0("gzip ", tblOut))

# Now filter based on the min_jaccard_frag
ovdf %>% filter(merged) %>% data.frame() -> ovdf

# Guess at how wide we need to make the barcodes to handle leading zeros
guess <- ceiling(log10(dim(nBC)[1]))

nBC_keep <- nBC; nBC_keep$DropBarcode <- ""; nBC_keep$OverlapReads <- ""

# Loop through and eat up barcodes
idx <- 1
while(dim(nBC)[1] > 0){
  barcode <- as.character(nBC[1,1])
  barcode_combine <- barcode
  OverlapReads = 0
  
  # Find friends that are similarly implicated and append from Barcode 1
  friendsRow1 <- which(barcode ==  ovdf[,"barc1", drop = TRUE])
  if(length(friendsRow1) > 0){
    friends1 <- as.character(ovdf[friendsRow1,"barc2"])
    #OverlapReads = OverlapReads + sum(ovdf[1:dim(ovdf)[1] %in% friendsRow1, "N_both"])
    #ovdf <- ovdf[1:dim(ovdf)[1] %ni% friendsRow1,]
    barcode_combine <- c(barcode_combine, friends1)
  }
  
  # Find friends that are similarly implicated and append from Barcode 2
  friendsRow2 <- which(barcode ==  ovdf[,"barc2", drop = TRUE])
  if(length(friendsRow2) > 0){
    friends2 <- as.character(ovdf[friendsRow2,"barc1"])
    #OverlapReads = OverlapReads + sum(ovdf[1:dim(ovdf)[1] %in% friendsRow2, "N_both"])
    #ovdf <- ovdf[1:dim(ovdf)[1] %ni% friendsRow2,]
    barcode_combine <- c(barcode_combine, friends2)
  }
  
  # If user species one to one, then only remove that one barcode
  if(one_to_one) barcode_combine <- barcode
  
  # Make a drop barcode and save our progress
  if(!barcoded_tn5){
    dropBarcode <- paste0(name, "_BC", formatC(idx, width=guess, flag="0", digits = 20), "_N", sprintf("%02d", length(barcode_combine)))
  } else {
    dropBarcode <- paste0(name, "_Tn5-", substrRight(barcode_combine), 
                          "_BC", formatC(idx, width=guess, flag="0", digits = 20),
                          "_N", sprintf("%02d", length(barcode_combine)))
  }
  
  # Annotate with new values
  nBC_keep[nBC_keep$BeadBarcode %in% barcode_combine, "DropBarcode"] <- dropBarcode
  #nBC_keep[nBC_keep$BeadBarcode %in% barcode_combine, "OverlapReads"] <- OverlapReads
  
  idx <- idx + 1
  
  # Remove barcodes that we've dealt with
  nBC <- nBC[nBC$BeadBarcode %ni% barcode_combine,]
}

write.table(nBC_keep[,c("BeadBarcode", "DropBarcode")],
            file = gsub(".implicatedBarcodes.csv$", ".barcodeTranslate.tsv", tblOut),
            quote = FALSE, row.names = FALSE, col.names = FALSE, sep = "\t")


# Finally, collate the NC values
tsvFiles <- list.files(rdsDir, full.names = TRUE, pattern = "_ncCount.tsv$")
tsvFiles <- tsvFiles[sapply(lapply(tsvFiles,file.info), function(x) x$size) > 0]

lapply(tsvFiles, read.table, header = FALSE) %>%
  rbindlist(fill = TRUE) %>% data.frame() -> inputDF
colnames(inputDF) <- c("NC_value", "i")
inputDF %>% group_by(NC_value) %>% 
  summarize(NumberOfFragments = sum(i)) -> NCtsv_out_df

nc_file_out <- gsub(".implicatedBarcodes.csv$", ".NCsumstats.tsv", tblOut)
write.table(NCtsv_out_df, file = nc_file_out, 
            quote = FALSE, row.names = FALSE, col.names = TRUE, sep = "\t")

options(warn=-1)

suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(tools)))
suppressMessages(suppressWarnings(library(GenomicRanges)))

"%ni%" <- Negate("%in%")

# This function / script for a given annotated chromosome fragments file saves a .rds file
# for each pair of barcodes given how many times they share an identical fragment in this 
# given chromosome


args <- commandArgs(trailingOnly = TRUE)

if(file_path_sans_ext(basename(args[1])) == "R"){
  i <- 2
} else { # Rscript
  i <- 0
}
nc_threshold <- as.numeric(args[i+1])
hq_beads_file <- args[i+2]
anno_bedpe_file <- args[i+3]
out_frag_rds_file <- args[i+4]
out_nc_count_file <- args[i+5]
regularize_threshold <- as.numeric(args[i+6])

# Don't execute-- strictly for testing
if(FALSE){
  nc_threshold <- 6
  hq_beads_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/final/jaccardPairsForIGV.HQbeads.tsv"
  anno_bedpe_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/temp/filt_split/jaccardPairsForIGV.chr12.frag.bedpe.annotated.tsv.gz"
  out_frag_rds_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/temp/frag_overlap/jaccardPairsForIGV.chr12_overlapCount.rds"
  out_nc_count_file <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/temp/frag_overlap/jaccardPairsForIGV.chr12_ncCount.tsv"
}


# Import fragments
frags <- fread(cmd = paste0("zcat < ", anno_bedpe_file), col.names = c("read_name", "chr", "start", "end", "bead_barcode"))
HQbeads <- fread(hq_beads_file, col.names = "beads", header = FALSE)[[1]]

# Filter 1 for eligible barcodes
frags_filt1 <- frags[bead_barcode %in% HQbeads] 

# Quantify NC + export
frags_filt1[, `:=` (n_distinct_barcodes = .N), by = list(start, end)]
write.table(frags_filt1 %>% group_by(n_distinct_barcodes) %>% summarise(count = n()), 
            file = out_nc_count_file, row.names = FALSE, col.names = FALSE, sep = "\t", quote = FALSE)

# Filter out high NC values + first pass PCR duplicate removal at the bead level
nc_value <- frags_filt1[n_distinct_barcodes <= nc_threshold] 
frags_filt2 <- nc_value[, .(PCRdupCount = .N), by = list(chr, start, end, bead_barcode)]

# Determine baseline numbers
barcodes <- frags_filt2[["bead_barcode"]]
XBtable <- table(barcodes)
whichKeep <- names(XBtable)
nKept <- as.numeric(XBtable); names(nKept) <- whichKeep
rm(XBtable)

# Pull out barcode for retained fragments
# CONSIDER: padding by 1bp to fix old behavior
make_insert_overlap <- function(element_in_table){
  
  # Find find overlaps of Tn5 insertions
  inserts_df <- data.table(
    chr = c(frags_filt2[["chr"]]),
    start = c(frags_filt2[[element_in_table]]),
    end = c(frags_filt2[[element_in_table]]) ,
    bead_barcode = c(frags_filt2[["bead_barcode"]])
  )
  GAfilt <- makeGRangesFromDataFrame(inserts_df)
  ov <- findOverlaps(GAfilt, GAfilt, type = "equal")

  # Make a dataframe of all combinations that have fragments overlapping
  bc1 = barcodes[queryHits(ov)[ queryHits(ov) !=  subjectHits(ov)]]
  bc2 = barcodes[subjectHits(ov)[ queryHits(ov) !=  subjectHits(ov)]]
  boo_barc <- bc1 != bc2  # filter out reads that map to the same barcode
  bc1 <- bc1[boo_barc]
  bc2 <- bc2[boo_barc]
  rm(ov)
  
  hugeDF <- data.table(
    barc1 = ifelse(bc1 > bc2, bc1, bc2),
    barc2 = ifelse(bc1 > bc2, bc2, bc1)
  )
  hugeDF
}

#Double to consider left and right inserts
hugeDF <- rbind(
  make_insert_overlap("start"),
  make_insert_overlap("end")
)

# Break up previous massive dplyr call for speed in data.table
implicatedPairs <- hugeDF[, .(n_both = .N/2), by = list(barc1, barc2)]
implicatedPairs <- implicatedPairs[n_both >= regularize_threshold]
  
# Export
saveRDS(implicatedPairs, file = out_frag_rds_file)

options(warn=-1)

suppressMessages(suppressWarnings(library(GenomicRanges)))
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(tools)))

"%ni%" <- Negate("%in%")

options(scipen=999)

# Working with the raw .bam file to generate QC statistics 
# Per barcode 

#-----------------
# Helper Functions
#-----------------

# See https://github.com/broadinstitute/picard/blob/master/src/main/java/picard/sam/DuplicationMetrics.java#L115
estimateLibrarySize <- function(nTotal, nUnique){
  
  f <- function(x, c, n) {
    return(c / x - 1 + exp(-n / x))
  }
  
  m = 1
  M = 100
  
  nDuplicates <- (nTotal - nUnique) + 1 # charity to handle only unique reads observed
  
  if (nUnique > nTotal | (f(m * nUnique, nUnique, nTotal) < 0) | nUnique < 0 | nTotal < 0 | nDuplicates < 0) {
    message("Library size returns 0 -- invalid inputs; check this cell more closely")
    return(0)
  }
  
  while (f(M * nUnique, nUnique, nTotal) > 0) {
    M <- M*10.0
  }
  
  for(i in seq(0, 40)) {
    r <-  (m + M) / 2.0
    u <- f(r * nUnique, nUnique, nTotal);
    if (u == 0) {
      break
    } else if (u > 0) {
      m = r
    } else if (u < 0) {
      M = r
    }
  }
  
  return(round(nUnique * (m + M) / 2.0))
}

estimateDuplicateRate <- function(nTotal, nUnique){
  round((nTotal-nUnique)/nTotal, 3)
}

#-----------------
# Parse arguments
#-----------------

args <- commandArgs(trailingOnly = TRUE)
if(file_path_sans_ext(basename(args[1])) == "R"){
  i <- 2
} else { # Rscript
  i <- 0
}

fragsFile <- args[i+1] 
tssFile <- args[i+2]
peakFile <- args[i+3]
simpleQCfile <- args[i+4] 
speciesMix <- args[i+5]
oneone <- args[i+6]
barcodeTranslateFile <- args[i+7]

# For dev only
if(FALSE){
  fragsFile <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/final/jaccardPairsForIGV.fragments.tsv.gz"
  tssFile <-  "~/dat/Research/BuenrostroResearch/lareau_dev/bap/bap/anno/TSS/hg19.refGene.TSS.bed"
  peakFile <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/data/test.small.peaks.bed"
  simpleQCfile <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/final/jaccardPairsForIGV.basicQC.tsv"
  speciesMix <- "no"
  oneone <- "no"
  barcodeTranslateFile <- "~/dat/Research/BuenrostroResearch/lareau_dev/bap/tests/bap2/final/jaccardPairsForIGV.barcodeTranslate.tsv"
}

# Import fragments
frag_df <- fread(fragsFile, header = FALSE)
if(dim(frag_df)[2] == 4){
  colnames(frag_df) = c("chr", "start", "end", "cell_barcode")
} else {
  colnames(frag_df) = c("chr", "start", "end", "cell_barcode", "read_name")
}
frag_gr <- makeGRangesFromDataFrame(frag_df)

# Set up TSS file for scoring
tssdf <- data.frame(fread(tssFile))
tssdf$V2 <- tssdf$V2 - 1000
tssdf$V3 <- tssdf$V3 + 1000

# Deal with TSS enrichment %
promoter <- makeGRangesFromDataFrame(tssdf, seqnames.field = "V1", start.field = "V2", end.field = "V3")
ovTSS <- findOverlaps(promoter, frag_gr)

frag_df$TSS <- as.numeric(1:dim(frag_df)[1] %in% subjectHits(ovTSS))
rm(ovTSS); rm(promoter)

# Deal with FRIP if we have a peak file
if(peakFile != "none"){
  suppressMessages(suppressWarnings(library(SummarizedExperiment)))
  peakdf <- data.frame(fread(peakFile))[,c(1,2,3)]
  colnames(peakdf) <- c("V1", "V2", "V3")
  peaks <- makeGRangesFromDataFrame(peakdf, seqnames.field = "V1", start.field = "V2", end.field = "V3")
  ovPEAK <- findOverlaps(peaks, frag_gr)
  frag_df$Peak <- as.numeric(1:dim(frag_df)[1] %in% subjectHits(ovPEAK))
  rm(peakdf) # Keep ovPEAK around for a while in case we build a SE
} else{
  frag_df$Peak <- 0
}

# Summarize frag attributes
frag_df$insert_size <- frag_df$end - frag_df$start
frag_df_summary <- frag_df[, list(meanInsertSize = mean(insert_size),
                                  medianInsertSize = median(insert_size),
                                  tssProportion = mean(TSS),
                                  FRIP = mean(Peak)), by = cell_barcode]

#Import existing QC stats
qc_df <- fread(simpleQCfile, header = TRUE)
qc_df$duplicateProportion <- estimateDuplicateRate(qc_df$totalNuclearFrags, qc_df$uniqueNuclearFrags)
qc_df$librarySize <- sapply(1:dim(qc_df)[1], function(i){
  estimateLibrarySize(as.numeric(qc_df[i,"totalNuclearFrags"]),as.numeric(qc_df[i,"uniqueNuclearFrags"]))})
qcStats <- merge(qc_df, frag_df_summary)

# Make it look pretty
qcStats$meanInsertSize <- round(qcStats$meanInsertSize, 1)
qcStats$duplicateProportion <- round(qcStats$duplicateProportion, 4)
qcStats$tssProportion <- round(qcStats$tssProportion, 4)
qcStats$FRIP <- round(qcStats$FRIP, 4)
colnames(qcStats)[1] <- "DropBarcode"
qcStats <- data.frame(qcStats)

# add barcodes back if we need to (specified with the one to one option)
if(oneone == "yes"){
  translateDF <- read.table(barcodeTranslateFile, header = TRUE, stringsAsFactors = FALSE)
  tvec <- translateDF[,1]; names(tvec) <- translateDF[,2]
  qcStats$OriginalBarcode <- tvec[as.character(qcStats$DropBarcode)] 
}

# Create a Summarized Experiment if we have a valid peak file
if(peakFile != "none"){
  
  # recall ovPEAK from above 
  id <- factor(frag_df[["cell_barcode"]], levels = as.character(qcStats$DropBarcode))
  countdf <- data.frame(peak = queryHits(ovPEAK), sample = as.numeric(id)[subjectHits(ovPEAK)]) %>%
    group_by(peak,sample) %>% summarise(count = n()) %>% data.matrix()
  #rm(ovPEAK)
  
  m <- Matrix::sparseMatrix(i = c(countdf[,1], length(peaks)), j= c(countdf[,2], 1), x = c(countdf[,3],0))
  colnames(m) <- levels(id)
  SE <- SummarizedExperiment(
    rowRanges = peaks, 
    assays = list(counts = m),
    colData = qcStats
  )
  saveRDS(SE, gsub(".basicQC.tsv$", ".SE.rds", simpleQCfile))
}

# Either way, export QC stats
write.table(qcStats,
            file = gsub(".basicQC.tsv$", ".QCstats.csv", simpleQCfile),
            quote = FALSE, row.names = FALSE, col.names = TRUE, sep = ",")
